{******************************************************************************
  Wordis -peli

  Tekijt:    K-J Kinnunen
              O Saikkonen
              T Heln
  Aika:       10.10.1997
  Muutokset:  14.12.1997
              + listty kommentteja
              + testattu palikoiden lismisen onnistumista
              + listty tasot looser, hacker, guru ja niiden ominaisuudet

  Lautha on Wordis -pelin runko, jossa tapahtuu pisteytys ja muu kokonaisuuden
  hallinta. WPalikka huolehtii omasta liikkumisestaan ja kommunikoi itsenisesti
  uuden sanan vaihtamiseksi WLaudan kanssa. WLaudassa on omat funktiot tausta-
  kuvan vaihtoa varten.
        Wordis -pelin funktiot/aliohjelmat on pyritty tekemn niin yksinker-
  taisiksi, ett uusien palikoiden lisminen onnistuisi vaivatta. Jos haluaa
  enemmn kuin peliss olevat 10 palikkaa, tarvii vain list WPalikoiden nimet
  funktion Palikka case-listaan.

  Projektiin mukaan:
             * Tm tiedosto = Lautha.pas
             * WLauta.pas
             * WPalikka.pas
             * WorAbout.pas

             * koetaulu.db samaan hakemistoon kuin projekti (tai jos haluat
               kytt omaa sanastoasi, niin mik tahansa *.db -tyyppinen
               tiedosto ky).


  Kyttohjeet:
             * Jos haluat kytt peliss taustakuvia, niin kirjoita kohtaan
               KuvanPolku oman kuvahakemistosi polku
             * Komponentissa WLauta pit asettaa propertyn TableName arvoksi
               koetaulu.db :n tarkka sijainti (=hakemistopolku)

******************************************************************************}
unit Lautha;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, WPalikka, ExtCtrls, WLauta, DBCtrls, Menus;

type
  TFormTesti = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Edit1: TEdit;
    Button1: TButton;
    LabelScore: TLabel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Exit1: TMenuItem;
    Options1: TMenuItem;
    Language1: TMenuItem;
    Level1: TMenuItem;
    Exit2: TMenuItem;
    Game1: TMenuItem;
    Button2: TButton;
    Label2: TLabel;
    Timer1: TTimer;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Bevel1: TBevel;
    Looser1: TMenuItem;
    Hacker1: TMenuItem;
    Guru1: TMenuItem;
    Suomi1: TMenuItem;
    Svenska1: TMenuItem;
    English1: TMenuItem;
    Help1: TMenuItem;
    Index1: TMenuItem;
    WLauta1: TWLauta;
    WPalikka1: TWPalikka;
    WPalikka2: TWPalikka;
    WPalikka3: TWPalikka;
    WPalikka4: TWPalikka;
    WPalikka5: TWPalikka;
    WPalikka6: TWPalikka;
    WPalikka7: TWPalikka;
    WPalikka8: TWPalikka;
    WPalikka9: TWPalikka;
    WPalikka10: TWPalikka;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Exit2Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Suomi1Click(Sender: TObject);
    procedure Svenska1Click(Sender: TObject);
    procedure English1Click(Sender: TObject);
    procedure Hacker1Click(Sender: TObject);
    procedure Looser1Click(Sender: TObject);
    procedure Guru1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Game1Click(Sender: TObject);
    procedure Index1Click(Sender: TObject);
  private
    FPalikoittenMaara : integer;
    pPalikka : TWPalikka;
    FMaxVauhti : integer;
    FOldScore : integer;
    FNewScore : integer;
    FKerroin : integer;
  public
    function  palikat(n : integer) : string;      // Palikoiden Captionin palautus
    procedure anna_seuraava_palikka(n : integer); // Varsinainen pohjelma
    procedure OnNewGame;                          // Uuden pelin alustukset
    procedure PeliLoppui;                         // Pelin lopetusrutiinit
    procedure JokuPalikkaLahtee;                  // Arvotaan pelin aloittava palikka
    function  Palikka(p : integer) : TWPalikka;   // Palikkalista
    procedure Score(s : integer);                 // Pelin pisteytys
  end;

var
  FormTesti: TFormTesti;

implementation

uses WorAbout;
{$R *.DFM}

//------- Alustukset formin luomisen yhteydess---------------------------------

procedure TFormTesti.FormCreate(Sender: TObject);
begin
    WLauta1.TableActive := True;
    FPalikoittenMaara := 10;
    FMaxVauhti := 5;
    FOldScore := 20;
    FNewScore := 0;
    FKerroin := 2;
    WLauta1.GetFileList;
    WLauta1.SetPolku(WLauta1.KuvanPolku);
    OnNewGame;
end;

//------ Kaikki peliss olevat WPalikat ----------------------------------------

function TFormTesti.Palikka(p : integer) : TWPalikka;
begin
  case p of
    0 : result := WPalikka1;
    1 : result := WPalikka2;
    2 : result := WPalikka3;
    3 : result := WPalikka4;
    4 : result := WPalikka5;
    5 : result := WPalikka6;
    6 : result := WPalikka7;
    7 : result := WPalikka8;
    8 : result := WPalikka9;
    9 : result := WPalikka10;
  else
    result := WPalikka3;
  end;
end;

//------ palautetaan liikkuvien palikoiden Caption -----------------------------

function TFormTesti.palikat(n : integer) : string;
begin
  if n >= FPalikoittenMaara then     // Jos on jo viimeinen palikka tarkistettu
  result := 'quit'                   // niin lopetetaan vertailu
  else
  begin
    pPalikka := Palikka(n);
    result := pPalikka.Caption;
    pPalikka := nil;
  end;
end;

//------- Haetaan nytlle palikka jossa uusi teksti ---------------------------

procedure TFormTesti.anna_seuraava_palikka(n : integer);
begin
  pPalikka := Palikka(n);
  pPalikka.Seuraava(pPalikka.LaudanNimi);
  pPalikka := nil;
  if n + 3 >= FPalikoittenMaara then     // Testi, ettei anneta vauhtia olemattomalle
    begin                                // palikalle
    pPalikka := Palikka(n + 3 - FPalikoittenMaara);// siirrytn alkupuolen palikoihin
    if pPalikka.Vauhti < FMaxVauhti then    // Katsotaan onko palikalla jo max -nopeus
    begin
      pPalikka.Vauhti := pPalikka.Vauhti + 1; // jollei, niin kasvatetaan nopeutta
      pPalikka := nil;                   // ( nopeuden kasvattaminen vois olla muuttuja
    end           // niin saatas levelin vaihtumista vhn tehostettua)
    else
      pPalikka.Vauhti := pPalikka.Vauhti;    // jos, niin pidetn vauhti samana
      pPalikka := nil;
    end
  else
    begin
    pPalikka := Palikka(n+3);        // jollei viel ollutkaan loppupn palikka

    if pPalikka.Vauhti < FMaxVauhti then
    begin
      pPalikka.Vauhti := pPalikka.Vauhti + 1;
      pPalikka := nil;
    end
    else
      pPalikka.Vauhti := pPalikka.Vauhti;
      pPalikka := nil;
    end;
end;



//******* Varsinainen pohjelma...  *******************************************

procedure TFormTesti.Button1Click(Sender: TObject);
var i, n : integer;
begin
     n := 0;

     while palikat(n) <> 'quit' do begin
       i := CompareText(Edit1.Text,palikat(n));
       if i = 0 then
         begin
           //WLauta1.AnnaSeuraavaBitmap;
           Score(n);
           anna_seuraava_palikka(n);

           //LabelScore.Caption := IntToStr(StrToInt(LabelScore.Caption) + (11 * Length(palikat(n))) );
           break;
           //MessageDlg('hazaa', mtWarning, [mbOK], 0);
         end;
       n := n + 1;
     end;
     Edit1.Clear;
end;

//------- Pisteiden laskeminen -------------------------------------------------

procedure TFormTesti.Score(s : integer);
begin
  FNewScore := FNewScore{StrToInt(LabelScore.Caption)} + (11 * Length(palikat(s)));
  LabelScore.Caption := IntToStr(FNewScore);
  if FNewScore >= FOldScore then
  begin
    WLauta1.AnnaSeuraavaBitmap;
    FMaxVauhti := FMaxVauhti + 1;
    //SeuraavaTaso !!
    FOldScore := FOldScore + FOldScore{(FKerroin * FOldScore)};
    //FKerroin := FKerroin + 1;
  end;
end;

//------- kun poistutaan -------------------------------------------------------

procedure TFormTesti.Exit2Click(Sender: TObject);
begin
     FormTesti.Close;
end;

//------- uusi peli ------------------------------------------------------------

procedure TFormTesti.New1Click(Sender: TObject);
begin
      PeliLoppui;
      OnNewGame;
      JokuPalikkaLahtee;
end;

//------- uusi peli ------------------------------------------------------------

procedure TFormTesti.Button2Click(Sender: TObject);
begin
  PeliLoppui;
  OnNewGame;
  JokuPalikkaLahtee;
  //FindNextControl(Self,True,True,True);
end;

//------- tutkitaan onko roskis jo tynn --------------------------------------

procedure TFormTesti.Timer1Timer(Sender: TObject);
begin
  Label3.Caption := IntToStr(WLauta1.RoskiksenTulos);
  if WLauta1.PeliLopussa then
  begin
    Timer1.Enabled := False;
    PeliLoppui;
    MessageDlg('hazaa, eli HighScore ei viel PELIT !! :)', mtInformation, [mbOK], 0);
    OnNewGame;
  end;
end;

//------- uuden pelin alussa tehtvt alustukset -------------------------------

procedure TFormTesti.OnNewGame;
var i : integer;
begin
  WLauta1.NollaaRoskis;
  FNewScore := 0;
  LabelScore.Caption := '0';
  Timer1.Enabled := True;
  //*************************
  for i := 0 to FPalikoittenMaara do   //FPalikoittenMaara -1 ??
  begin                                // alistetaan palikat sanataulun nimill
    pPalikka := Palikka(i);            // ja laitetaan vasemman reunan taa
    pPalikka.Seuraava(pPalikka.LaudanNimi); // piiloon
    pPalikka.Left := 0 - pPalikka.Width;
    pPalikka := nil;
  end;
end;

//------- kun peli loppuu ------------------------------------------------------

procedure TFormTesti.PeliLoppui;
var i : integer;
begin
  for i:=0 to FPalikoittenMaara do
  begin
    pPalikka := Palikka(i);
    pPalikka.Vauhti := 0;
    pPalikka := nil;
  end;
  // HighScoren tarkistus !!!
end;

//------- arvotaan pelin aloittava palikka -------------------------------------

procedure TFormTesti.JokuPalikkaLahtee;
var mika : integer;
begin
  Randomize;
  mika := random(10);
    pPalikka := Palikka(mika);
    pPalikka.Vauhti := 2;
    pPalikka := nil;
end;

//------- sanaston kielen valinta ----------------------------------------------

procedure TFormTesti.Suomi1Click(Sender: TObject);
begin
     Suomi1.Checked := True;
     PeliLoppui;
     WLauta1.Kieli := 0;
     OnNewGame;
end;

procedure TFormTesti.Svenska1Click(Sender: TObject);
begin
     Svenska1.Checked := True;
     PeliLoppui;
     WLauta1.Kieli := 1;
     OnNewGame;
end;

procedure TFormTesti.English1Click(Sender: TObject);
begin
     English1.Checked := True;
     PeliLoppui;
     WLauta1.Kieli := 2;
     OnNewGame;
end;

//------- pelin tasojen valinta ------------------------------------------------

procedure TFormTesti.Hacker1Click(Sender: TObject);
begin
  Hacker1.Checked := True;
  Looser1.Checked := False;
  Guru1.Checked := False;
  FMaxVauhti := 5;
  PeliLoppui;
  OnNewGame;
end;

procedure TFormTesti.Looser1Click(Sender: TObject);
begin
  Looser1.Checked := True;
  Guru1.Checked := False;
  Hacker1.Checked := False;
  FMaxVauhti := 3;
  PeliLoppui;
  OnNewGame;
end;

procedure TFormTesti.Guru1Click(Sender: TObject);
begin
  Guru1.Checked := True;
  Looser1.Checked := False;
  Hacker1.Checked := False;
  FMaxVauhti := 12;
  PeliLoppui;
  OnNewGame;
end;

procedure TFormTesti.Exit1Click(Sender: TObject);
begin
  MessageDlg('HighScore ei pelit tss versiossa', mtInformation, [mbOK], 0);
end;

procedure TFormTesti.Game1Click(Sender: TObject);
begin
  FormAboutWordis.Show;
end;

procedure TFormTesti.Index1Click(Sender: TObject);
begin
  Application.HelpFile := 'wordis.HLP';
  Application.HelpJump('Wordiksen_sisallysluettelo');
end;

end.
