{******************************************************************************
  WLauta toimii WPalikoiden pohjana

  Tekijt:    K-J Kinnunen
              O Saikkonen
              T Heln
  Aika:       10.10.1997
  Muutokset:  12.12.1997
              + listty kommentteja
              13.12.1997
              + fiksailtu TeeKuva -funktiota -> listty mm. try-expect -lohko
              + Muutettu piirra -funktio TeeKuva -funktioksi, joka muodostaa
                panelin kokoisen kuvan pienemmista kuvista muuttujaan FBitMappi

              14.2.2005 / Miika Nurminen
               + muutettu tietokanta bde/paradoxista ado/accessiin.

  WLauta on TPanelista tehty taustakuvallinen tietokannan omaava pelialusta.
  Alkuperiseen paneliin listtiin tietokantaominaisuuksien lismisen jlkeen
  ominaisuudet:
    DbName,TableName,TableActive:      Nm ominaisuudet ovat samoja kuin
    TTablessa
    Kieli:      Ilmaisee monettako saraketta taulu ky lpi. Tss ohjelmassa
    on ajateltu, ett kolmella ensimmisell sarakkeella olisivat kielet
    suomi, ruotsi ja englanti.
    PBAlign:    WLautaan 'ymptyn' PaintBoxin Align ominaisuus sellaisenaan
    KuvanPolku: Yksink. string -muuttuja, jolla kerrotaan mist
    hakemistopolusta pelin kuvat lytyvt
    KuvanMaski: Peite, jolla saadaan StringList:iin  vaikka *.bmp tai *.wmf
    - muotoisia tiedostojen nimi (tai ihan mit tahansa)
  Lisksi WLaudassa on iso kasa tietokannan ja PaintBoxin hallintaan liittyvi
  aliohjelmia. WLautaan listtiin mys Wordis -peliin kuuluva roskiksen
  ksittely ja siihen liittyvt funktiot


******************************************************************************}
unit WLauta;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables,ExtCtrls, StdCtrls, adodb;



type
  TWLauta = class(TPanel)
  private
    FTable       : TAdoTable;
    FDbName      : string;
    FWTableName  : string;
    FTableActive : boolean;
    FKieli       : integer;
    FPBox        : TPaintBox;
    FPBAlign     : TAlign;
    FKuvaLista   : TStringList;
    FPolku       : string;
    FMaski       : string;
    FMoneskoKuva : integer;
    FTaustaKuva  : string;
    FRosokis     : integer;
    FBitMappi    : TBitMap;
  protected
  public
    constructor Create(AOwner : TComponent);   override;
    procedure   SetDbName(s :  string);                   // ALIAS - nimen asetus
    procedure   SetWTableName(a : string);                // Taulun nimen asetus
    procedure   SetTableActive(b : boolean);
    procedure   SetPBAlign(Spb : TAlign);
    procedure   SetKieli(k : integer);
    procedure   SetPolku(pol : string);
    procedure   SetMaski(mas : string);
//------------ Tietokanta -funktiot --------------------------------------------
    function    Lopussa : boolean;             virtual;   // Taulun ksittely
    procedure   Ensimmaiseen;                  virtual;
    function    OtaSolu : String;              virtual;
    procedure   Seuraava;                      virtual;
//------------ Bitmap -funktiot ------------------------------------------------
    procedure   TeeKuva(filekset : string);                // piirretn PaintBoxille
    procedure   WLautaPaint(Sender: TObject);             // kun WM_Paint -kutsu saapuu
    procedure   GetFileList;                              // Muodostetaan tiedostolista
    function    AnnaSeuraavaBitmap : string;
//------------ Roskis -funktiot ------------------------------------------------
    procedure   NollaaRoskis;
    function    Roskis : integer;
    function    RoskiksenTulos : integer;
    function    PeliLopussa : Boolean;
  published
    property DbName:string       read FDbName       write SetDbName;
    property TableName:string    read FWTableName   write SetWTableName;
    property TableActive:boolean read FTableActive  write SetTableActive;
    property Kieli : integer     read FKieli        write SetKieli;
    property PBAlign : TAlign    read FPBAlign      write SetPBAlign;
    property KuvanPolku:string   read FPolku        write SetPolku;
    property KuvanMaski:string   read FMaski        write SetMaski;
  end;

procedure Register;

implementation

  constructor TWLauta.Create(AOwner : TComponent);
  begin
    inherited;
      FTable        := TAdoTable.Create(self);
      FPBox         := TPaintBox.Create(self);
      FPBox.Parent  := Self;
      Self.Align    := alClient;
      FPBox.Width   := 1024;           // Jostain syyst PBAlign ei toimi ekalla kerralla
      FPBox.Height  := 768;
      PBAlign       := alClient;       //PBoxin Align WLaudan kokoiseksi
      FPBox.Enabled := False;  //PaintBox pois plt, jotta lautaa voi alussa liikutella -> OnPaint
      FKuvaLista    := TStringList.Create;
      DbName        := '';
      TableName     := '';
      TableActive   := False;
      FMoneskoKuva  := 0;
      FPBox.OnPaint := WLautaPaint;    //OnPaint -tapahtuman ksittelijksi WLautaPaint
      KuvanMaski    := '*.bmp';
      FRosokis      := 0;
  end;


//------------------------------------------------------------------------------
//---  Set -funktiot                                                         ---
//---                                                                        ---
//---   Sef -funktioilla asetetaan propertyjen arvot                         ---
//---                                                                        ---
//------------------------------------------------------------------------------

 procedure TWLauta.SetDbName(s : string);
    begin
      FdbName := s;
      FTable.ConnectionString:='Provider=Microsoft.Jet.OLEDB.4.0;Data Source='+ExtractFileDir(ParamStr(0))+'\'+s+';Persist Security Info=False';
//      FTable.DatabaseName := FdbName;
    end;

  procedure TWLauta.SetWTableName(a : string);
     begin
     FWTableName := a;
     FTable.TableName := FWTableName;
     end;


   procedure TWLauta.SetTableActive(b : boolean);
     begin
     FTableActive := b;
     FTable.Active := FTableActive;
   end;

   procedure TWLauta.SetKieli(k : integer);
   begin
     FKieli := k;
   end;

   procedure TWLauta.SetPBAlign(Spb : TAlign);
   begin
     FPBAlign := Spb;
     FPBox.Align := FPBAlign;
   end;

   procedure TWLauta.SetPolku(pol : string);
   begin
     FPolku := pol;                         // Asetetaan property KuvanPolku
     FPBox.Enabled := True;                 // Laitetaan Panelin PBox -ominaisuus plle
     FKuvaLista.Clear;                      // Otetaan vanhat tiedostot pois listasta
     GetFileList;                           // ja tytetn uusilla
     FTaustaKuva := AnnaSeuraavaBitmap;     // Lopuksi otetaan uusi taustakuva kyttn
   end;

   procedure   TWLauta.SetMaski(mas : string);
   begin
     FMaski := mas;
   end;



//******************************************************************************
//***  Sanataulukon ksittelyfunktiot.                                       ***
//***                                                                        ***
//***   Sanataulukon (= mik tahansa tietokantataulu) ksittelyss kytetn ***
//***  aivan normaaleja TTablen komentoja. Komennot on vain laitettu omiin   ***
//***  funktioihinsa, jotta niit voidaan ksitell ulkopuolelta (WPalikka)  ***
//***                                                                        ***
//******************************************************************************

   function TWLauta.Lopussa : boolean;
   begin
     if FTable.EOF then                 // Jos taulun osoitin on lopussa niin..
          result := true
     else
          result := false;
   end;

//------------------------------------------------------------------------------

   procedure TWLauta.Ensimmaiseen;
   begin
     FTable.First;                      // Siirrytn ensimmiseen
   end;

//------------------------------------------------------------------------------

   function TWLauta.OtaSolu : String;
   begin                                              // Palautetaan oikean
     result := FTable.Fields[FKieli].AsString;        //kielen kohdalta teksti
   end;

//------------------------------------------------------------------------------

   procedure TWLauta.Seuraava;
   begin
     FTable.Next;                        // ..ja otetaan seuraava..
   end;


//
//  Roskiksen ksittely                                                   
//                                                                        
//   Roskis toimii vain yksinkertaisena laskurina. Kun laskuri saavuttaa  
//  kymmenen kpl:n rajan, niin peli on ohitse.                            
//                                                                        
//

  function   TWLauta.Roskis : integer;
  begin
    FRosokis := FRosokis+1;           // Tuli missaus, listn arvoa
    result := FRosokis;
  end;

//------------------------------------------------------------------------------

  procedure TWLauta.NollaaRoskis;
  begin
    FRosokis := 0;                    // Ilmeisesti uusi peli -> nollataan!
  end;

//------------------------------------------------------------------------------

  function TWLauta.PeliLopussa : Boolean;
  begin
    if FRosokis >= 10 then            // Onko virheiden mr jo tynn??
      result := True
    else
      result := False;
  end;

//------------------------------------------------------------------------------

  function TWLauta.RoskiksenTulos : integer;
  begin
    result := FRosokis;              // Tllainen mr missej tll hetkell
  end;


//''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
//'''  Taustakuvan ja kuvatiedostojen ksittely                              '''
//'''                                                                        '''
//'''   Ennenkuin taustakuvaa voidaan tehd, pit muodostaa lista           '''
//'''  tiedostossa olevista kuvista (GetFileList -aliohjelma). Kun lista on  '''
//'''  luotu, voidaan listaa ksitell esim. siirtyen askel kerrallaan       '''
//'''  listassa eteenpin (AnnaSeuraavaBitmap). Varsinainen koko panelin     '''
//'''  kokoinen piirtminen tapahtuu TeeKuva -funktiossa. TeeKuva -funktio   '''
//'''  tytt koko panelin pienillkin kuvilla. Kuvan pivitys tapahtuu     '''
//'''  funktiossa WLautaPaint, eli tt ajetaan silloin kun tulee WM_PAINT   '''
//'''  viesti.                                                               '''
//'''                                                                        '''
//''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

procedure TWLauta.GetFileList;
var i : integer; SearchRec : TSearchRec;
begin
   i := FindFirst(FPolku+FMaski, 0, SearchRec);      // Haetaan annetusta polusta
   try                                               // maskin mukainen ensimm.
     while i = 0 do                                  // tiedosto
     begin
       FKuvaLista.Add(SearchRec.Name);               // Tytetn FKuvaLista
       i := FindNext(SearchRec);                     // tiedostosta lytivll
     end;                                            // kuvilla
   except
     MessageDlg('Tiedostosta ei lydy maskin mukaisia kuvia', mtWarning, [mbOK], 0);
     FindClose(SearchRec);                           // Jos ei lytynyt, vapautetaan resurssit
     raise;
   end;
end;

//------------------------------------------------------------------------------

   function TWLauta.AnnaSeuraavaBitmap : string;
   begin
   if FMoneskoKuva >= FKuvaLista.Count -1 then // ks. onko kuva listaosoitin mennyt
     begin                                     // viimeisest yl
       FMoneskoKuva := 0 ;
     end
   else                                        // jos ei niin seuraava ja piirretn
     FTaustaKuva := FKuvaLista.Strings[FMoneskoKuva];
     FBitMappi.Free;                    // Vapautetaan resurssit ennen uuden kuvan luomista
     TeeKuva(FPolku+FTaustaKuva);
     Result := FTaustaKuva;             // vanhaa jmist, mutta yh paikoillaan, jos sattuisi tarvimaan
     FMoneskoKuva := FMoneskoKuva + 1;
   end;

//------------------------------------------------------------------------------

   procedure   TWLauta.WLautaPaint(Sender: TObject);
   begin
     if FPBox.Enabled = false then exit; // jollei PBox piirtokyvytn, niin
     FPBox.Canvas.Draw(0,0,FBitMappi); // piirretn kuvaa aina WM_PAINT -viestin saapuessa
   end;

//------------------------------------------------------------------------------

procedure TWLauta.TeeKuva(filekset : string);
var BitMap : TBitMap;
    kerroinX, kerroinY : real;
    i, n : integer;
begin
    BitMap := TBitMap.Create;
    FBitMappi := TBitMap.Create;      // Luodaan varsinainen OnPaint -tapahtumassa kytettv kuva
    FBitMappi.Width := FPBox.Width;   // ja annetaan sille oikea pituus ja
    FBitMappi.Height := FPBox.Height; // leveys.
        try
          BitMap.LoadFromFile(filekset);
        except
          MessageDlg('Tiedostosta ei lydy maskin mukaisia kuvia, tai polun lopusta puuttuu  \ -merkki', mtWarning, [mbOK], 0);
          FPBox.Enabled := false;  // Jos ei kuvan lataaminen onnistunut laitetaan
          exit;  // PaintBoxi kyttkelvottomaksi, jotta voidaan liikutella tyhj
          raise; // WLautaa ja sen jlkeen poistutaan
        end;
        kerroinX := FPBox.ClientWidth/Bitmap.Width;      // Tutkitaan montako kertaa
        kerroinY := FPBox.ClientHeight/Bitmap.Height;    // kuvaa pit toistaa,
        i := 0;                                          // jotta saadaan koko panelin
        while i <= kerroinX do                           // kokoinen kuva.
        begin
          n := 0;
          while n <= kerroinY do
          begin
            FBitMappi.Canvas.Draw(i*Bitmap.Width,n*Bitmap.Height,BitMap);
              //FPBox.Canvas.Draw(i*Bitmap.Width,n*Bitmap.Height,BitMap);
              //FPBox.Canvas.Draw(0,0,FBitMappi);
            n := n + 1;
          end;
          i := i + 1;
        end;
    FPBox.Canvas.Draw(0,0,FBitMappi); // Piirretn kuva ensimmisen kerran PaintBoxin canvakselle..
                                      // loput piirtotapahtumat OnPaintin ksittelijss
    BitMap.Free;     // Vapautetaan luomisessa kytetyn bitmapin resurssit
end;

//------------------------------------------------------------------------------

procedure Register;
begin
  RegisterComponents('OmatSotkut', [TWLauta]);
end;

end.
