unit WPalikka;

{******************************************************************************
  WPalikka on Wordis pelin trke yksittinen osa

  Tekijt:    K-J Kinnunen
              O Saikkonen
              T Heln
  Aika:       10.10.1997
  Muutokset:  12.12.1997
              + listty kommentteja

  WPalikka on TStaticText -komponentin plle tehty liikkuva laatikko.
  Mukaan on laitettu oma timer. Ominaisuuksiin listtiin timerin takia
  TimerActive ja TimerInterval.  Vauhti -ominaisuus ilmoittaa palikan siirtymn
  vaakasuunnassa. LaudanNimi - ominaisuudella sdetn, ett mink WLaudan
  tietokantaa WPalikka kytt.
              WPalikassa on funktiolla Seuraava otetaan seuraava teksti palikan
  captioniin ja aliohjelmalla VaihdetaankoVari tutkitaan onko palikka
  vrinvaihtoalueella. VaihdaVari vaihtaa WPalikan vrin.

******************************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables,StdCtrls,ExtCtrls,WLauta;

type
  TWPalikka = class(TStaticText)
  private
         FTimer : TTimer;
         FTimerActive : boolean;
         FTimerInterval : integer;
         FVauhti : integer;
         Fw : TWLauta;
  protected
  public
    constructor Create(AOwner : TComponent); override;
    procedure SetTimerActive(t : boolean);
    procedure SetTimerInterval(i : integer);
    procedure Seuraava(w : TWLauta);
    procedure SetLaudanNimi(w : TWLauta);
//----------- Palikan liikuttelu- ja vrinvaihtofunktiot ---------------------
    procedure WordisTimer(Sender: TObject);
    procedure SetVauhti(v : integer);
    procedure VaihdaVari(Vari :integer);
    procedure VaihdetaankoVari;
  published
    property Color        default clGreen;
    property TimerActive:boolean read FTimerActive write SetTimerActive default true;
    property TimerInterval: integer read FTimerInterval write SetTimerInterval default 10;
    property Vauhti : integer read FVauhti write SetVauhti default 0;
    property LaudanNimi : TWLauta read Fw write SetLaudanNimi;
    property AutoSize          default True;
  end;

procedure Register;

implementation

  constructor TWPalikka.Create(AOwner : TComponent);
  begin
      inherited;
      BorderStyle := sbsSunken;
      Font.Size := 18;
      AutoSize := True;
      FTimer := TTimer.Create(self);
      FTimer.OnTimer := WordisTimer;
      TimerInterval := 10;
      TimerActive := True;
  end;


//-----------------------------------------------------------------------------
{ Propertyjen asetusfunktiot }

   procedure TWPalikka.SetVauhti(v : integer);
   begin
     if LaudanNimi = nil then
     begin
       MessageDlg('Olet unohtanut antaa Wordis -laudan nimen (->property LaudanNimi). Tarkista mys, ett WLaudan tietokanta on aktiivinen (=TableActive -> True)', mtWarning, [mbOK], 0);
       exit; //kun Fw on tyhj, ei voida laittaa vauhtia
     end
     else
     FVauhti := v;
   end;

   procedure TWPalikka.SetTimerInterval(i : integer);
   begin
     FTimerInterval := i;
     FTimer.Interval := FtimerInterval;
   end;

   procedure TWPalikka.SetTimerActive(t : boolean);
   begin
     FTimerActive := t;
     FTimer.Enabled := FTimerActive;
   end;

   procedure TWPalikka.SetLaudanNimi(w : TWLauta);
   begin
     Fw := w;       // Kerrotaan WPalikalle, mink WLaudan tietokantaa kytetn
   end;


//******************************************************************************
//**   Vrinvaihto

   procedure TWPalikka.VaihdetaankoVari;       // Tutkitaan miss kohtaa palikka on menossa
   begin                                       // ja annetaan vri sen mukaan
     if Self.left + Self.Width < Parent.ClientWidth / 3 then
       VaihdaVari(0);
     if Self.left + Self.Width >= Parent.ClientWidth / 3 then
       VaihdaVari(1);
     if Self.left + Self.Width >= (Parent.ClientWidth/3)*2 then
       VaihdaVari(Random(10));
       //VaihdaVari(2);
   end;

//------------------------------------------------------------------------------
//-- Uusi teksti WPalikan Captioniin

   procedure TWPalikka.Seuraava(w : TWLauta);
   begin
     if (w.Lopussa) then          // testi onko taulun osoitin lopussa
     begin
       w.Ensimmaiseen;
       Caption := w.OtaSolu;
     end
     else
       Caption := w.OtaSolu;     // muuten otetaankin sitten normaalisti uusi
                                 // teksti palikan captioniin
     w.Seuraava;
     Self.left := 1 - Self.Width;    // ja lhdetn alustan vasemmasta reunasta
   end;

//------------------------------------------------------------------------------
//-- WPalikan liikuttelu

   procedure TWPalikka.WordisTimer(Sender: TObject);
   begin
     Self.left := Self.left + FVauhti;           // palikan liikuttelu
     VaihdetaankoVari;
     if Self.left + Self.Width  >= Parent.ClientWidth - FVauhti then   //testi onko jo pdyss
     begin
          Fw.Roskis;                            // jos pdyss niin tuli yksi missi
          VaihdaVari(0);
          try                                   // ja otetaan seuraava sana
            Seuraava(Fw);
          except
            Self.left := 1 - Self.Width;        // jos tietokantaa ei lydy, lhdetn alusta
            raise;
          end;
     end;
   end;

//------------------------------------------------------------------------------

   procedure TWPalikka.VaihdaVari(Vari :integer);
   begin
     case Vari of                     // sijainnin mukaan vaihtuvat vrit
       0: Self.Color := clGreen;
       1: Self.Color := clYellow;
       2: Self.Color := clRed;
       3: Self.Color := clMaroon;
       4: Self.Color := clOlive;
       5: Self.Color := clNavy;
       6: Self.Color := clLime;
       7: Self.Color := clPurple;
       8: Self.Color := clTeal;
       9: Self.Color := clWhite;
     else
       Self.Color := clGreen;
     end;
   end;

//------------------------------------------------------------------------------

procedure Register;
begin
  RegisterComponents('OmatSotkut', [TWPalikka]);
end;

end.
